searchNodes=[{"doc":"A TP1 operational transformation implementation based heavily on ot-text , but modified to be invertable. In this OT type, operations are represented as traversals of an entire string, with any final retain components implicit. This means that given the text &quot;Foz Baz&quot;, the operation needed to change it to &quot;Foo Bar Baz&quot; would be represented thusly: [ 2 , %{ d : &quot;z&quot; } , %{ i : &quot;o Bar&quot; } ] Notice that the final retain component, 4 (to skip over &quot; Baz&quot;) is implicit and it not included.","ref":"OT.Text.html","title":"OT.Text","type":"module"},{"doc":"Callback implementation for OT.Type.apply/2 .","ref":"OT.Text.html#apply/2","title":"OT.Text.apply/2","type":"function"},{"doc":"See OT.Text.Application.apply!/2 .","ref":"OT.Text.html#apply!/2","title":"OT.Text.apply!/2","type":"function"},{"doc":"Callback implementation for OT.Type.compose/2 .","ref":"OT.Text.html#compose/2","title":"OT.Text.compose/2","type":"function"},{"doc":"See OT.Text.Composition.compose_many/1 .","ref":"OT.Text.html#compose_many/1","title":"OT.Text.compose_many/1","type":"function"},{"doc":"Initialize a blank text datum.","ref":"OT.Text.html#init/0","title":"OT.Text.init/0","type":"function"},{"doc":"","ref":"OT.Text.html#random_op/1","title":"OT.Text.random_op/1","type":"function"},{"doc":"Callback implementation for OT.Type.transform/2 .","ref":"OT.Text.html#transform/2","title":"OT.Text.transform/2","type":"function"},{"doc":"Callback implementation for OT.Type.transform_index/2 .","ref":"OT.Text.html#transform_index/2","title":"OT.Text.transform_index/2","type":"function"},{"doc":"A string that this OT type can operate on","ref":"OT.Text.html#t:datum/0","title":"OT.Text.datum/0","type":"type"},{"doc":"The application of a text operation to a piece of text. CodeSandbox custom version to ignore error_mismatch, as JS doesn't provide the deletion material","ref":"OT.Text.Application.html","title":"OT.Text.Application","type":"module"},{"doc":"Apply an operation to a piece of text. Given a piece of text and an operation, iterate over each component in the operation and apply it to the given text. If the operation is valid, the function will return {:ok, new_state} where new_state is the text with the operation applied to it. If the operation is invalid, an {:error, atom} tuple will be returned. Examples iex&gt; OT.Text.Application . apply ( &quot;Foo&quot; , [ 3 , &quot; Bar&quot; ] ) { :ok , &quot;Foo Bar&quot; } iex&gt; OT.Text.Application . apply ( &quot;Foo&quot; , [ - 4 ] ) { :error , &quot;The operation&#39;s base length must be equal to the string&#39;s length. String length: 3, base length: 4&quot; }","ref":"OT.Text.Application.html#apply/2","title":"OT.Text.Application.apply/2","type":"function"},{"doc":"","ref":"OT.Text.Application.html#apply!/2","title":"OT.Text.Application.apply!/2","type":"function"},{"doc":"The result of an apply/2 function call, representing either success or error in application of an operation","ref":"OT.Text.Application.html#t:apply_result/0","title":"OT.Text.Application.apply_result/0","type":"type"},{"doc":"The composition of two non-concurrent operations into a single operation.","ref":"OT.Text.Composition.html","title":"OT.Text.Composition","type":"module"},{"doc":"Compose two operations into a single equivalent operation. The operations are composed in such a way that the resulting operation has the same effect on document state as applying one operation and then the other: S ○ compose(Oa, Ob) = S ○ Oa ○ Ob . Example iex&gt; OT.Text.Composition . compose ( [ &quot;Bar&quot; ] , [ 3 ] ) { :ok , [ &quot;Bar&quot; ] }","ref":"OT.Text.Composition.html#compose/2","title":"OT.Text.Composition.compose/2","type":"function"},{"doc":"","ref":"OT.Text.Composition.html#compose_many/1","title":"OT.Text.Composition.compose_many/1","type":"function"},{"doc":"A list of components that iterates over and/or modifies a piece of text","ref":"OT.Text.Operation.html","title":"OT.Text.Operation","type":"module"},{"doc":"An operation, which is a list consisting of t:OT.Text.Component.retain/0 , t:OT.Text.Component.insert/0 , and t:OT.Text.Component.delete/0 components","ref":"OT.Text.Operation.html#t:t/0","title":"OT.Text.Operation.t/0","type":"type"},{"doc":"The transformation of two concurrent operations such that they satisfy the TP1 property of operational transformation.","ref":"OT.Text.Transformation.html","title":"OT.Text.Transformation","type":"module"},{"doc":"Transform an operation against another operation. Given an operation A that occurred at the same time as operation B against the same text state, transform the components of operation A such that the state of the text after applying operation A and then operation B is the same as after applying operation B and then the transformation of operation A against operation B: S ○ Oa ○ transform(Ob, Oa) = S ○ Ob ○ transform(Oa, Ob) This function also takes a third side argument that indicates which operation came later. This is important when deciding whether it is acceptable to break up insert components from one operation or the other.","ref":"OT.Text.Transformation.html#transform/2","title":"OT.Text.Transformation.transform/2","type":"function"},{"doc":"","ref":"OT.Text.Transformation.html#transform_index/2","title":"OT.Text.Transformation.transform_index/2","type":"function"},{"doc":"A behaviour for implementing an operational transformation type. An operational transformation (OT) type is a module that is able to apply operations on a piece of data in any order and guarantee convergence of the two resulting data states.","ref":"OT.Type.html","title":"OT.Type","type":"behaviour"},{"doc":"Apply an operation to a datum of the type operated on by the OT type.","ref":"OT.Type.html#c:apply/2","title":"OT.Type.apply/2","type":"callback"},{"doc":"Compose two operations together into a single operation.","ref":"OT.Type.html#c:compose/2","title":"OT.Type.compose/2","type":"callback"},{"doc":"Invoked in order to initialize a &quot;blank&quot; datum of the type operated on by the OT type.","ref":"OT.Type.html#c:init/0","title":"OT.Type.init/0","type":"callback"},{"doc":"Transform an operation against another operation.","ref":"OT.Type.html#c:transform/2","title":"OT.Type.transform/2","type":"callback"},{"doc":"Transform an index based on an operation.","ref":"OT.Type.html#c:transform_index/2","title":"OT.Type.transform_index/2","type":"callback"},{"doc":"","ref":"Rust.OT.html","title":"Rust.OT","type":"module"},{"doc":"","ref":"Rust.OT.html#apply/2","title":"Rust.OT.apply/2","type":"function"},{"doc":"","ref":"Rust.OT.html#compose/2","title":"Rust.OT.compose/2","type":"function"},{"doc":"","ref":"Rust.OT.html#compose_many/1","title":"Rust.OT.compose_many/1","type":"function"},{"doc":"","ref":"Rust.OT.html#transform/2","title":"Rust.OT.transform/2","type":"function"},{"doc":"","ref":"Rust.OT.html#transform_index/2","title":"Rust.OT.transform_index/2","type":"function"},{"doc":"This Elixir library contains an implementation of operational transformations for strings. It is the same general algorithm as ottypes/text , but made invertible. The implementation of the library a Rust NIF (with rustler_precompiled support) for increased throughput. The original implementation of this library, written in pure Elixir, can be found here .","ref":"README.md.html","title":"OT","type":"extras"},{"doc":"Install the package by adding ot_ex to your list of dependencies in mix.exs along with the hex option : def deps do [ { :ot_ex , &quot;~&gt; 0.2.0-rc1&quot; , hex : :ot_ex_rust } ] end Then run mix deps.get .","ref":"README.md.html#installation","title":"OT - Installation","type":"extras"},{"doc":"To run the basic tests, run mix test . There are also some longer fuzz tests available that are quite slow. These can be included in the suite by running mix test --include slow_fuzz . This repo also has Credo and Dialyzer checks that can be run with mix lint .","ref":"README.md.html#testing","title":"OT - Testing","type":"extras"},{"doc":"ISC License Copyright 2017 Jonathan Clem Permission to use, copy, modify, and/or distribute this software for any purpose with or without fee is hereby granted, provided that the above copyright notice and this permission notice appear in all copies. THE SOFTWARE IS PROVIDED &quot;AS IS&quot; AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.","ref":"LICENSE.html","title":"License","type":"extras"}]